package net.java.amateras.uml.editpart;

import java.beans.PropertyChangeEvent;

import net.java.amateras.uml.UMLPlugin;
import net.java.amateras.uml.model.DependencyModel;

import org.eclipse.draw2d.ConnectionLocator;
import org.eclipse.draw2d.Graphics;
import org.eclipse.draw2d.IFigure;
import org.eclipse.draw2d.Label;
import org.eclipse.draw2d.PolylineConnection;
import org.eclipse.draw2d.PolylineDecoration;

public class DependencyEditPart extends AbstractUMLConnectionEditPart {

	private Label label;
	
	protected IFigure createFigure() {
		DependencyModel model = (DependencyModel)getModel();
		
		label = new Label();
		if(!model.getStereoType().equals("")){
			label.setText("<<" + model.getStereoType() + ">>");
		}
		
		PolylineConnection connection = new PolylineConnection();
		connection.setLineStyle(Graphics.LINE_DASH);
		connection.setTargetDecoration(new PolylineDecoration());
		connection.add(label, new ConnectionLocator(connection, ConnectionLocator.MIDDLE));
		connection.setConnectionRouter(UMLPlugin.getDefault().getConnectionRouter());
		
		return connection;
	}
	
	public void propertyChange(PropertyChangeEvent evt) {
		DependencyModel model = (DependencyModel)getModel();
		if(!model.getStereoType().equals("")){
			label.setText("<<" + model.getStereoType() + ">>");
		} else {
			label.setText("");
		}
		refreshVisuals();
	}
	
	protected Label getStereoTypeLabel() {
		return label;
	}

}
